import { LoadingBarModule, LoadingBarService } from '@ngx-loading-bar/core';
import { Injectable, NgModule } from '@angular/core';
import { HTTP_INTERCEPTORS, HttpClientModule, HttpEventType } from '@angular/common/http';
import 'rxjs/add/operator/do';

class LoadingBarInterceptor {
    /**
     * @param {?} _loadingBarService
     */
    constructor(_loadingBarService) {
        this._loadingBarService = _loadingBarService;
    }
    /**
     * @param {?} req
     * @param {?} next
     * @return {?}
     */
    intercept(req, next) {
        return next.handle(req).do((event) => {
            if (event.type === HttpEventType.Sent) {
                this._loadingBarService.startLoading();
            }
        }, () => this._loadingBarService.endLoading(), () => this._loadingBarService.endLoading());
    }
}
LoadingBarInterceptor.decorators = [
    { type: Injectable },
];
/**
 * @nocollapse
 */
LoadingBarInterceptor.ctorParameters = () => [
    { type: LoadingBarService, },
];

class LoadingBarHttpClientModule {
}
LoadingBarHttpClientModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    HttpClientModule,
                    LoadingBarModule,
                ],
                exports: [
                    HttpClientModule,
                    LoadingBarModule,
                ],
                providers: [
                    { provide: HTTP_INTERCEPTORS, useClass: LoadingBarInterceptor, multi: true },
                ],
            },] },
];
/**
 * @nocollapse
 */
LoadingBarHttpClientModule.ctorParameters = () => [];

/**
 * Generated bundle index. Do not edit.
 */

export { LoadingBarHttpClientModule, LoadingBarInterceptor as ɵa };
//# sourceMappingURL=http-client.js.map
